<?php

class Kids_Fashion_Customizer_Notify {

	private $config = array(); // Declare $config property
	
	private $kids_fashion_recommended_actions;
	
	private $recommended_plugins;
	
	private static $instance;
	
	private $kids_fashion_recommended_actions_title;
	
	private $kids_fashion_recommended_plugins_title;
	
	private $dismiss_button;
	
	private $kids_fashion_install_button_label;
	
	private $kids_fashion_activate_button_label;
	
	private $kids_fashion_deactivate_button_label;

	
	public static function init( $config ) {
		if ( ! isset( self::$instance ) && ! ( self::$instance instanceof Kids_Fashion_Customizer_Notify ) ) {
			self::$instance = new Kids_Fashion_Customizer_Notify;
			if ( ! empty( $config ) && is_array( $config ) ) {
				self::$instance->config = $config;
				self::$instance->setup_config();
				self::$instance->setup_actions();
			}
		}

	}

	
	public function setup_config() {

		global $kids_fashion_customizer_notify_recommended_plugins;
		global $kids_fashion_customizer_notify_kids_fashion_recommended_actions;

		global $kids_fashion_install_button_label;
		global $kids_fashion_activate_button_label;
		global $kids_fashion_deactivate_button_label;

		$this->kids_fashion_recommended_actions = isset( $this->config['kids_fashion_recommended_actions'] ) ? $this->config['kids_fashion_recommended_actions'] : array();
		$this->recommended_plugins = isset( $this->config['recommended_plugins'] ) ? $this->config['recommended_plugins'] : array();

		$this->kids_fashion_recommended_actions_title = isset( $this->config['kids_fashion_recommended_actions_title'] ) ? $this->config['kids_fashion_recommended_actions_title'] : '';
		$this->kids_fashion_recommended_plugins_title = isset( $this->config['kids_fashion_recommended_plugins_title'] ) ? $this->config['kids_fashion_recommended_plugins_title'] : '';
		$this->dismiss_button            = isset( $this->config['dismiss_button'] ) ? $this->config['dismiss_button'] : '';

		$kids_fashion_customizer_notify_recommended_plugins = array();
		$kids_fashion_customizer_notify_kids_fashion_recommended_actions = array();

		if ( isset( $this->recommended_plugins ) ) {
			$kids_fashion_customizer_notify_recommended_plugins = $this->recommended_plugins;
		}

		if ( isset( $this->kids_fashion_recommended_actions ) ) {
			$kids_fashion_customizer_notify_kids_fashion_recommended_actions = $this->kids_fashion_recommended_actions;
		}

		$kids_fashion_install_button_label    = isset( $this->config['kids_fashion_install_button_label'] ) ? $this->config['kids_fashion_install_button_label'] : '';
		$kids_fashion_activate_button_label   = isset( $this->config['kids_fashion_activate_button_label'] ) ? $this->config['kids_fashion_activate_button_label'] : '';
		$kids_fashion_deactivate_button_label = isset( $this->config['kids_fashion_deactivate_button_label'] ) ? $this->config['kids_fashion_deactivate_button_label'] : '';

	}

	
	public function setup_actions() {

		// Register the section
		add_action( 'customize_register', array( $this, 'kids_fashion_plugin_notification_customize_register' ) );

		// Enqueue scripts and styles
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'kids_fashion_customizer_notify_scripts_for_customizer' ), 0 );

		/* ajax callback for dismissable recommended actions */
		add_action( 'wp_ajax_quality_customizer_notify_dismiss_action', array( $this, 'kids_fashion_customizer_notify_dismiss_recommended_action_callback' ) );

		add_action( 'wp_ajax_ti_customizer_notify_dismiss_recommended_plugins', array( $this, 'kids_fashion_customizer_notify_dismiss_recommended_plugins_callback' ) );

	}

	
	public function kids_fashion_customizer_notify_scripts_for_customizer() {

		wp_enqueue_style( 'kids-fashion-customizer-notify-css', get_template_directory_uri() . '/core/includes/customizer-notice/css/kids-fashion-customizer-notify.css', array());

		wp_enqueue_style( 'plugin-install' );
		wp_enqueue_script( 'plugin-install' );
		wp_add_inline_script( 'plugin-install', 'var pagenow = "customizer";' );

		wp_enqueue_script( 'updates' );

		wp_enqueue_script( 'kids-fashion-customizer-notify-js', get_template_directory_uri() . '/core/includes/customizer-notice/js/kids-fashion-customizer-notify.js', array( 'customize-controls' ));
		wp_localize_script(
			'kids-fashion-customizer-notify-js', 'kidsfashionCustomizercompanionObject', array(
				'ajaxurl'            => admin_url( 'admin-ajax.php' ),
				'template_directory' => get_template_directory_uri(),
				'base_path'          => admin_url(),
				'activating_string'  => __( 'Activating', 'kids-fashion' ),
			)
		);

	}

	
	public function kids_fashion_plugin_notification_customize_register( $wp_customize ) {

		
		require_once get_template_directory() . '/core/includes/customizer-notice/kids-fashion-customizer-notify-section.php';

		$wp_customize->register_section_type( 'Kids_Fashion_Customizer_Notify_Section' );

		$wp_customize->add_section(
			new Kids_Fashion_Customizer_Notify_Section(
				$wp_customize,
				'kids-fashion-customizer-notify-section',
				array(
					'title'          => $this->kids_fashion_recommended_actions_title,
					'plugin_text'    => $this->kids_fashion_recommended_plugins_title,
					'dismiss_button' => $this->dismiss_button,
					'priority'       => 0,
				)
			)
		);

	}

	
	public function kids_fashion_customizer_notify_dismiss_recommended_action_callback() {

		global $kids_fashion_customizer_notify_kids_fashion_recommended_actions;

		$action_id = ( isset( $_GET['id'] ) ) ? $_GET['id'] : 0;

		echo esc_html( $action_id ); /* this is needed and it's the id of the dismissable required action */ 

		if ( ! empty( $action_id ) ) {
			
			if ( get_option( 'kids_fashion_customizer_notify_show' ) ) {

				$kids_fashion_customizer_notify_show_kids_fashion_recommended_actions = get_option( 'kids_fashion_customizer_notify_show' );
				switch ( $_GET['todo'] ) {
					case 'add':
						$kids_fashion_customizer_notify_show_kids_fashion_recommended_actions[ $action_id ] = true;
						break;
					case 'dismiss':
						$kids_fashion_customizer_notify_show_kids_fashion_recommended_actions[ $action_id ] = false;
						break;
				}
				update_option( 'kids_fashion_customizer_notify_show', $kids_fashion_customizer_notify_show_kids_fashion_recommended_actions );

				
			} else {
				$kids_fashion_customizer_notify_show_kids_fashion_recommended_actions = array();
				if ( ! empty( $kids_fashion_customizer_notify_kids_fashion_recommended_actions ) ) {
					foreach ( $kids_fashion_customizer_notify_kids_fashion_recommended_actions as $kids_fashion_lite_customizer_notify_recommended_action ) {
						if ( $kids_fashion_lite_customizer_notify_recommended_action['id'] == $action_id ) {
							$kids_fashion_customizer_notify_show_kids_fashion_recommended_actions[ $kids_fashion_lite_customizer_notify_recommended_action['id'] ] = false;
						} else {
							$kids_fashion_customizer_notify_show_kids_fashion_recommended_actions[ $kids_fashion_lite_customizer_notify_recommended_action['id'] ] = true;
						}
					}
					update_option( 'kids_fashion_customizer_notify_show', $kids_fashion_customizer_notify_show_kids_fashion_recommended_actions );
				}
			}
		}
		die(); 
	}

	
	public function kids_fashion_customizer_notify_dismiss_recommended_plugins_callback() {

		$action_id = ( isset( $_GET['id'] ) ) ? $_GET['id'] : 0;

		echo esc_html( $action_id ); /* this is needed and it's the id of the dismissable required action */

		if ( ! empty( $action_id ) ) {

			$kids_fashion_lite_customizer_notify_show_recommended_plugins = get_option( 'kids_fashion_customizer_notify_show_recommended_plugins' );

			switch ( $_GET['todo'] ) {
				case 'add':
					$kids_fashion_lite_customizer_notify_show_recommended_plugins[ $action_id ] = false;
					break;
				case 'dismiss':
					$kids_fashion_lite_customizer_notify_show_recommended_plugins[ $action_id ] = true;
					break;
			}
			update_option( 'kids_fashion_customizer_notify_show_recommended_plugins', $kids_fashion_lite_customizer_notify_show_recommended_plugins );
		}
		die(); 
	}

}
